unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, MPlayer, StdCtrls, Placemnt, Buttons, Spin, MaxMin, RXSlider;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    FormStorage1: TFormStorage;
    ListBox1: TListBox;
    OpenDialog1: TOpenDialog;
    MPlayer: TMediaPlayer;
    Timer1: TTimer;
    FileIndex: TSpinEdit;
    Panel3: TPanel;
    AutoNext: TCheckBox;
    Loop: TCheckBox;
    ClearBtn: TBitBtn;
    BitBtn1: TBitBtn;
    PlayBtn: TBitBtn;
    StopBtn: TBitBtn;
    PlayPos: TRxSlider;
    procedure ClearBtnClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure FormStorage1RestorePlacement(Sender: TObject);
    procedure PlayPosChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  PlayFlag: Boolean=False;

implementation

{$R *.DFM}

procedure TForm1.ClearBtnClick(Sender: TObject);
begin
  MPlayer.Stop;
  ListBox1.Clear;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var I: Integer;
begin
  with OpenDialog1,ListBox1 do if Execute then begin
    for I:=0 to Files.Count-1 do Items.Add(Files[I]);
    if (Items.Count>0) and (ItemIndex<0) then ItemIndex:=0;
  end;
end;

procedure TForm1.PlayBtnClick(Sender: TObject);
begin
  with MPlayer,ListBox1 do begin
    if (Items.Count=0) then exit;
    if (FileIndex.Value>Items.Count) then FileIndex.Value:=0;
    if SelCount=0 then Selected[FileIndex.Value]:=True;
    StopBtn.BringToFront;
    if Mode=mpPaused then Resume else begin
      Close; FileName:=Items.Strings[ItemIndex]; Open;
      PlayPos.MinValue:=0;
      PlayPos.Value:=0;
      PlayPos.MaxValue:=Length;
      Panel2.Refresh;
      Play;
    end;
    PlayFlag:=True;
  end;
end;

procedure TForm1.StopBtnClick(Sender: TObject);
begin
  PlayBtn.BringToFront;
  MPlayer.Pause;
  PlayFlag:=False;
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
begin
  with MPlayer do begin
    Stop;
    FileName:=ListBox1.Items.Strings[ListBox1.ItemIndex]; Open;
    FileIndex.Value:=ListBox1.ItemIndex;
    PlayPos.MinValue:=0;
    PlayPos.Value:=0;
    PlayPos.MaxValue:=Length;
    PlayBtn.Click;
  end;
end;

procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var I,J: Integer; P: Boolean;
begin
  if Key=VK_DELETE then with ListBox1, MPlayer do begin
    Timer1.Enabled:=False;
    P:=(MPlayer.Mode=mpPlaying);
    MPlayer.Stop;
    for I:=0 to SelCount do
      for J:=0 to Items.Count-1 do
        if Selected[J] then begin Items.Delete(J); break; end;
    ItemIndex:=min(ItemIndex,Items.Count-1);
    FileIndex.Value:=ItemIndex;
    Selected[FileIndex.Value]:=True;
    MPlayer.FileName:=Items.Strings[ItemIndex]; Open;
    PlayPos.MinValue:=0;
    PlayPos.Value:=0;
    PlayPos.MaxValue:=Length;
    Panel2.Refresh;
    if P then MPlayer.Play;
    Timer1.Enabled:=True;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Tag:=Timer1.Tag+1;
  PlayPos.OnChange:=nil;
  PlayPos.Value:=MPlayer.Position;
  PlayPos.Repaint;
  PlayPos.OnChange:=PlayPosChange;
  if (Timer1.Tag mod 10)=0 then
  with MPlayer,ListBox1 do
    if (Mode=mpStopped) and PlayFlag and AutoNext.Checked and (Items.Count>0) then begin
      Panel2.Refresh;
      if FileIndex.Value<Items.Count-1 then begin
        Selected[FileIndex.Value]:=False;
        FileIndex.Value:=FileIndex.Value+1;
        Selected[FileIndex.Value]:=True;
        Close; FileName:=Items.Strings[FileIndex.Value]; Open;
        PlayPos.MinValue:=0;
        PlayPos.Value:=0;
        PlayPos.MaxValue:=Length;
        Play;
      end else if Loop.Checked then begin
        Selected[FileIndex.Value]:=False;
        FileIndex.Value:=0;
        Selected[FileIndex.Value]:=True;
        Close; FileName:=Items.Strings[FileIndex.Value]; Open;
        PlayPos.MinValue:=0;
        PlayPos.Value:=0;
        PlayPos.MaxValue:=Length;
        Play;
      end;
    end;
end;

procedure TForm1.FormStorage1RestorePlacement(Sender: TObject);
begin
  with MPlayer,ListBox1 do begin
    if FileIndex.Value>=Items.Count then FileIndex.Value:=0;
    if Items.Count>0 then begin
      Selected[FileIndex.Value]:=True;
      FileName:=Items.Strings[FileIndex.Value]; Open;
      PlayPos.MinValue:=0;
      PlayPos.Value:=0;
      PlayPos.MaxValue:=Length;
    end;
  end;
end;

procedure TForm1.PlayPosChange(Sender: TObject);
var P: Boolean;
begin
  try
    P:=(MPlayer.Mode=mpPlaying);
    MPlayer.Position:=PlayPos.Value;
    if P then MPlayer.Play;
  except
  end;
end;

end.
